Description: upstream: hardden ps2pdf fork
Origin: debian
Forwarded: meant to be submitted
Author: Jerome Benoit <calculus@rezozer.net>
Last-Update: 2015-05-29

--- a/image-formats/ps.cc
+++ b/image-formats/ps.cc
@@ -301,54 +301,50 @@
 	return true;
 }
 
-bool pdfprint (class bit_buffer &pixel, FILE *psfile, int resolution, const char *fileloc) {
-
-	printf("DPI: %i\n", resolution); 
-	psprint(pixel, psfile, resolution);	
-	
-	int status;
-	pid_t pID = fork();
-	
-	if (pID == 0) 	 {
-		execl("/usr/bin/ps2pdf", "/usr/bin/ps2pdf", fileloc, "temp.pdf",  (char *) 0);
-		_exit (EXIT_FAILURE);
-	}
-	if (pID > 0) 
-	{
-		waitpid(pID, &status, 0);	
-		pid_t pID2 = fork();
-		if (pID2 == 0) 	{
-			execl("/bin/mv", "/bin/mv", "temp.pdf", fileloc,  (char *) 0);
-			_exit (EXIT_FAILURE);
+static bool pdfprint_XXX_ps2pdf (const char *fileloc) {
+	char *shellcommand=NULL;
+	bool response=true;
+	if (system(NULL)) {
+		if (!((asprintf(&shellcommand,
+						"/usr/bin/ps2pdf "
+							"%s %s-tmp"
+					" && "
+						"/bin/mv --force %s-tmp %s"
+					" || "
+						"exit 0"
+					"",
+				fileloc,fileloc,fileloc,fileloc)
+				) < 0)) {
+			if (system(shellcommand)) {
+				ostrstream ostr;
+				ostr << "Error converting file " << fileloc << " (ps2pdf subprocess)";
+				Misc::alert (ostr);
+				response=false;
+				ostr.freeze(false);
+			}
+			free(shellcommand);
 		}
 	}
-	return true;
-	
+	else {
+		ostrstream ostr;
+		ostr << "Error converting file " << fileloc << " (no command processor)";
+		Misc::alert (ostr);
+		response=false;
+		ostr.freeze(false);
+		}
+	return response;
+}
+
+bool pdfprint (class bit_buffer &pixel, FILE *psfile, int resolution, const char *fileloc) {
+	//printf("DPI: %i\n", resolution);
+	psprint(pixel, psfile, resolution);
+	return pdfprint_XXX_ps2pdf (fileloc);
 }
 
 
 bool pdfprint_color (class RgbBuffer &pixel, FILE *psfile, int resolution,const char *fileloc) {
-	
-	
-	psprint_color(pixel, psfile, resolution);	
-	
-	int status;
-	pid_t pID = fork();
-	
-	if (pID == 0) 	 {
-		execl("/usr/bin/ps2pdf", "/usr/bin/ps2pdf", fileloc, "temp.pdf",  (char *) 0);
-		_exit (EXIT_FAILURE);
-	}
-	if (pID > 0) 
-	{
-		waitpid(pID, &status, 0);	
-		pid_t pID2 = fork();
-		if (pID2 == 0) 	{
-			execl("/bin/mv", "/bin/mv", "temp.pdf", fileloc,  (char *) 0);
-			_exit (EXIT_FAILURE);
-		}
-	}
-	return true;
+	psprint_color(pixel, psfile, resolution);
+	return pdfprint_XXX_ps2pdf (fileloc);
 }
 // ============================================================================
 // End of ps.cc
